Index: java/main/src/main/java/com/framsticks/gui/MainFrame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/MainFrame.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/gui/MainFrame.java	(revision 84)
@@ -1,7 +1,6 @@
 package com.framsticks.gui;
 
-import com.framsticks.gui.components.Control;
-import com.framsticks.gui.view.*;
 import com.framsticks.gui.windows.console.ConsoleFrame;
+import com.framsticks.util.swing.MenuConstructor;
 import org.apache.log4j.Logger;
 
@@ -11,4 +10,5 @@
 import java.awt.event.ActionEvent;
 import java.awt.event.ActionListener;
+import java.awt.event.KeyEvent;
 import java.awt.event.WindowAdapter;
 import java.awt.event.WindowEvent;
@@ -17,7 +17,8 @@
  * Application Main Frame.
  */
+@SuppressWarnings("serial")
 public class MainFrame extends Frame {
 
-	private final static Logger LOGGER = Logger.getLogger(MainFrame.class.getName());
+	private final static Logger log = Logger.getLogger(MainFrame.class.getName());
 
 	JButton start, stop, step;
@@ -28,96 +29,128 @@
 	public MainFrame(final Browser browser) {
 		super("Framsticks Network Client", browser);
-		LOGGER.debug("creating main frame");
+		log.debug("creating main frame");
 
 		statusBar = new JLabel("not connected");
-
-
-	}
+	}
+
 
 	@Override
 	public void configure() {
 		super.configure();
+
+		new MenuConstructor(fileMenu)
+			.add(null, new AbstractAction("Console") {
+				@Override
+				public void actionPerformed(ActionEvent actionEvent) {
+					showConsoleFrame();
+				}
+			})
+			.add(KeyStroke.getKeyStroke(KeyEvent.VK_G, ActionEvent.CTRL_MASK), new AbstractAction("Goto") {
+				@Override
+				public void actionPerformed(ActionEvent actionEvent) {
+					browser.autoResolvePath("/simulator/genepools/groups/0", null);
+					// browser.autoResolvePath("/simulator/populations/groups/0", null;
+					// browser.autoResolvePath("/simulator/genepools/groups/0/genotypes", null);
+					// browser.autoResolvePath("/simulator/populations/groups", null);
+				}
+			})
+			.add(null, new AbstractAction("Disconnect") {
+				@Override
+				public void actionPerformed(ActionEvent actionEvent) {
+					disconnect();
+				}
+			})
+			.add(null, new AbstractAction("Quit") {
+				@Override
+				public void actionPerformed(ActionEvent actionEvent) {
+				}
+			})
+			;
+
 		setFrameProperties();
 	}
 
-	private void onConnectionEstablished() {
-        assert isActive();
-
-        addNodeActionToTreePopupMenu("Open in console", new NodeAction() {
-            @Override
-            public void actionPerformed(TreeNode treeNode) {
-                assert isActive();
-                //showConsoleFrame().setCommandLine("info " + treeNode.getNode().getPath());
-            }
-        });
-
-
-
-/*
-        browser.addNodeActionToTreePopupMenu("Resolve recursively", new NodeAction() {
-            @Override
-            public void actionPerformed(TreeNode treeNode) {
-                final Child child = treeNode.getChild();
-                //server.invokeLater(new Runnable() {
-                    @Override
-                    public void run() {
-                        resolveRecursively(child);
-                    }
-                });
-            }
-        });
-*/
-
-        addNodeActionToTreePopupMenu("Store in file", new NodeAction() {
-            @Override
-            public void actionPerformed(final TreeNode treeNode) {
-
-/*
-                final Node node = treeNode.getNode();
-                server.invokeLater(new Runnable() {
-                    @Override
-                    public void run() {
-                        try {
-                            LOGGER.info("storing");
-                            //File file = new File();
-                            PrintStream file = new PrintStream("/home/piotr/Desktop/test.param");
-                            StoreStream stream = new StoreStream(file, server.getManager());
-                            stream.store(node);
-
-                        } catch (FileNotFoundException e) {
-                            e.printStackTrace();
-                        }
-                    }
-                });
-*/
-            }
-        });
-
-/*
-        arguments.forEach("resolve", new UnaryFunctor<Boolean, String>() {
-            @Override
-            public Boolean call(final String s) {
-                server.getManager().resolvePath(s, new StateFunctor() {
-                    @Override
-                    public void call(Exception e) {
-                        if (e != null) {
-                            LOGGER.error("failed to resolve: " + s);
-                            return;
-                        }
-                        LOGGER.info("succeeded to resolve: " + s);
-
-                    }
-                });
-                return true;
-            }
-        });
-*/
-
-        /*
-        arguments.forEach("console", new UnaryFunctor<Boolean, String>() {
+	// private void onConnectionEstablished() {
+		// assert isActive();
+
+		// addNodeActionToTreePopupMenu("Open in console", new NodeAction() {
+			// @Override
+			// public void actionPerformed(TreeNode treeNode) {
+				// assert isActive();
+			// }
+		// });
+
+
+
+
+	// 	// browser.addNodeActionToTreePopupMenu("Resolve recursively", new NodeAction() {
+	// 	// 	@Override
+	// 	// 	public void actionPerformed(TreeNode treeNode) {
+	// 	// 		final Child child = treeNode.getChild();
+	// 	// 		//server.invokeLater(new Runnable() {
+	// 		// 		@Override
+	// 		// 		public void run() {
+	// 		// 			resolveRecursively(child);
+	// 		// 		}
+	// 		// 	});
+	// 	// }
+	// 	// });
+
+
+		// // addNodeActionToTreePopupMenu("Store in file", new NodeAction() {
+		// //     @Override
+		// //     public void actionPerformed(final TreeNode treeNode) {
+		// //         // final Node node = treeNode.getNode();
+		// //         // server.invokeLater(new Runnable() {
+		// //         //     @Override
+		// //         //     public void run() {
+		// //         //         try {
+		// //         //             log.info("storing");
+		// //         //             //File file = new File();
+		// //         //             StoreStream stream = new StoreStream(file, server.getManager());
+		// //         //             stream.store(node);
+		// //         //         } catch (FileNotFoundException e) {
+		// //         //             e.printStackTrace();
+		// //         //         }
+		// //         //     }
+		// //         // });
+		// //     }
+		// // });
+
+
+	// 	// arguments.forEach("resolve", new UnaryFunctor<Boolean, String>() {
+	// 	// 	@Override
+	// 	// 	public Boolean call(final String s) {
+	// 	// 		server.getManager().resolvePath(s, new StateFunctor() {
+	// 	// 			@Override
+	// 	// 			public void call(Exception e) {
+	// 	// 				if (e != null) {
+	// 	// 					log.error("failed to resolve: " + s);
+	// 	// 					return;
+	// 	// 				}
+	// 	// 				log.info("succeeded to resolve: " + s);
+	// 	// 			}
+	// 	// 		});
+	// 	// 		return true;
+	// 	// 	}
+	// 	// });
+
+
+	// 	// arguments.forEach("console", new UnaryFunctor<Boolean, String>() {
+	// 	// 	@Override
+	// 	// 	public Boolean call(String s) {
+	// 	// 		showConsoleFrame().setCommandLine(s);
+	// 	// 		return true;
+	// 	// 	}
+	// 	// });
+	// }
+
+	public void setSimulationRunning(final boolean run) {
+		assert isActive();
+		/*
+		remoteInstance.invokeLater(new Runnable() {
 			@Override
-			public Boolean call(String s) {
-				showConsoleFrame().setCommandLine(s);
-				return true;
+			public void run() {
+				remoteInstance.setRunning(run);
 			}
 		});
@@ -125,23 +158,11 @@
 	}
 
-	public void setSimulationRunning(final boolean run) {
-        assert isActive();
-        /*
-        remoteInstance.invokeLater(new Runnable() {
-            @Override
-            public void run() {
-                remoteInstance.setRunning(run);
-            }
-        });
-        */
-	}
-
 	/**
 	 * Creates panel with start, step, stop buttons.
 	 */
-    @Override
+	@Override
 	protected JPanel createLeftTopPanel() {
-        assert isActive();
-        Dimension buttonDimension = new Dimension(45, 45);
+		assert isActive();
+		Dimension buttonDimension = new Dimension(45, 45);
 
 		JPanel panel = new JPanel();
@@ -161,5 +182,5 @@
 
 		step = new JButton(ImageProvider.loadImage(ImageProvider.SIM_STEP));
-        /*
+		/*
 		step.addActionListener(new ActionListener() {
 
@@ -212,6 +233,6 @@
 	 */
 	private void setFrameProperties() {
-        assert isActive();
-        setMinimumSize(this.getPreferredSize());
+		assert isActive();
+		setMinimumSize(this.getPreferredSize());
 		setSize(this.getPreferredSize());
 		setMaximumSize(screenDimension);
@@ -224,7 +245,7 @@
 		addWindowListener(new WindowAdapter() {
 			public void windowClosing(WindowEvent e) {
-                assert isActive();
-                /*
-                if (connection != null) {
+				assert isActive();
+				/*
+				if (connection != null) {
 					connection.close();
 				}
@@ -237,58 +258,11 @@
 
 	public ConsoleFrame showConsoleFrame() {
-        assert isActive();
-        /*
-        ConsoleFrame consoleFrame = new ConsoleFrame(connection);
+		assert isActive();
+		/*
+		ConsoleFrame consoleFrame = new ConsoleFrame(connection);
 		consoleFrame.show(MainFrame.this);
 		return consoleFrame;
 		*/
-        return null;
-	}
-
-	/**
-	 * Creates menu bar.
-	 *
-	 * @return JMenuBar Menu bar.
-	 */
-    @Override
-	protected JMenuBar createMenu() {
-        assert isActive();
-        final JMenuBar menuBar = new JMenuBar();
-		final JMenu menu = new JMenu("Main");
-
-		final JMenuItem consoleItem = new JMenuItem("Console");
-		consoleItem.addActionListener(new ActionListener() {
-
-			public void actionPerformed(ActionEvent e) {
-				showConsoleFrame();
-			}
-
-		});
-
-        /*
-		final JMenuItem serverLogItem = new JMenuItem("Sever Log");
-		serverLogItem.addActionListener(new ActionListener() {
-
-			public void actionPerformed(ActionEvent e) {
-				serverLogFrame.show(MainFrame.this);
-			}
-
-		});
-		*/
-
-		final JMenuItem disconnectItem = new JMenuItem("Disconnect");
-		disconnectItem.addActionListener(new ActionListener() {
-
-			public void actionPerformed(ActionEvent e) {
-				disconnect();
-			}
-		});
-
-		/** @todo do something proper with UI on close */
-		menu.add(consoleItem);
-		//menu.add(serverLogItem);
-		menu.add(disconnectItem);
-		menuBar.add(menu);
-		return menuBar;
+		return null;
 	}
 
@@ -297,6 +271,6 @@
 	 */
 	private void disconnect() {
-        assert isActive();
-        //remoteInstance.disconnect();
+		assert isActive();
+		//remoteInstance.disconnect();
 		browser.clear();
 		onWindowClosing();
@@ -308,11 +282,11 @@
 	 */
 	private void onWindowClosing() {
-        assert isActive();
+		assert isActive();
 
 	}
 
 	public void setRunningButtons(boolean running) {
-        assert isActive();
-        step.setEnabled(!running);
+		assert isActive();
+		step.setEnabled(!running);
 		stop.setEnabled(running);
 		start.setEnabled(!running);
Index: java/main/src/main/java/com/framsticks/gui/ModifiablePanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/ModifiablePanel.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/ModifiablePanel.java	(revision 84)
@@ -0,0 +1,72 @@
+package com.framsticks.gui;
+
+import org.apache.log4j.Logger;
+
+import javax.swing.*;
+import java.awt.*;
+import java.awt.event.ActionEvent;
+import java.awt.event.ActionListener;
+
+/**
+ * @author Piotr Sniegowski
+ */
+@SuppressWarnings("serial")
+public abstract class ModifiablePanel extends Panel {
+
+	private static final Logger log = Logger.getLogger(ModifiablePanel.class.getName());
+
+	/**
+	 * Pane to which components will be added.
+	 */
+	protected JPanel contentPanel;
+
+	final protected JLabel label;
+	final protected JButton applyButton;
+
+	public ModifiablePanel(Panel.Parameters parameters) {
+		super(parameters);
+		log.debug("create panel for type: " + className);
+
+
+		contentPanel = new JPanel();
+		contentPanel.setLayout(new BoxLayout(contentPanel, BoxLayout.PAGE_AXIS));
+		JScrollPane scroll = new JScrollPane(contentPanel);
+		//scroll.setBorder(BorderFactory.createEtchedBorder());
+
+		JPanel pageEndPanel = new JPanel();
+		pageEndPanel.setLayout(new BoxLayout(pageEndPanel, BoxLayout.X_AXIS));
+		pageEndPanel.add(Box.createHorizontalGlue());
+
+		applyButton = new JButton("Apply");
+		applyButton.addActionListener(new ActionListener() {
+			public void actionPerformed(ActionEvent e) {
+				applyChanges();
+			}
+		});
+		pageEndPanel.add(applyButton);
+
+		pageEndPanel.add(Box.createHorizontalStrut(10));
+		pageEndPanel.setPreferredSize(new Dimension(0, 30));
+
+		label = new JLabel();
+		JPanel centerPanel = new JPanel();
+		centerPanel.setLayout(new BorderLayout());
+		centerPanel.add(Box.createHorizontalStrut(10), BorderLayout.LINE_START);
+		centerPanel.add(Box.createHorizontalStrut(10), BorderLayout.LINE_END);
+		centerPanel.add(label, BorderLayout.PAGE_START);
+		centerPanel.add(scroll, BorderLayout.CENTER);
+		centerPanel.add(pageEndPanel, BorderLayout.PAGE_END);
+
+		this.setLayout(new BorderLayout());
+		this.add(centerPanel, BorderLayout.CENTER);
+		//this.add(new ViewerTest(), BorderLayout.PAGE_END);
+	}
+
+	@Override
+	public void setCurrentTreeNode(TreeNode node) {
+		super.setCurrentTreeNode(node);
+	}
+
+	protected abstract void applyChanges();
+
+}
Index: java/main/src/main/java/com/framsticks/gui/MultiPanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/MultiPanel.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/MultiPanel.java	(revision 84)
@@ -0,0 +1,54 @@
+package com.framsticks.gui;
+
+import com.framsticks.params.AccessInterface;
+
+import javax.swing.*;
+import java.awt.*;
+import java.util.List;
+
+/**
+ * Author: Piotr Śniegowski
+ */
+@SuppressWarnings("serial")
+public class MultiPanel extends Panel {
+
+	protected final List<Panel> panels;
+	protected final JTabbedPane tabbedPane;
+
+
+	public MultiPanel(Panel.Parameters parameters, List<Panel> panels) {
+		super(parameters);
+		this.panels = panels;
+		tabbedPane = new JTabbedPane();
+
+		for (Panel p : panels) {
+			assert p.getClassName().equals(getClassName());
+			assert p.getEndpointAtFrame() == getEndpointAtFrame();
+			tabbedPane.add(p.getTitle(), p);
+		}
+
+		this.setLayout(new BorderLayout());
+		this.add(tabbedPane, BorderLayout.CENTER);
+
+	}
+
+	@Override
+	public void pullValuesFromLocalToUser(AccessInterface access) {
+		for (Panel p : panels) {
+			p.pullValuesFromLocalToUser(access);
+		}
+	}
+
+	@Override
+	public String getTitle() {
+		return className;
+	}
+
+	@Override
+	public void setCurrentTreeNode(TreeNode currentTreeNode) {
+		super.setCurrentTreeNode(currentTreeNode);
+		for (Panel p : panels) {
+			p.setCurrentTreeNode(currentTreeNode);
+		}
+	}
+}
Index: java/main/src/main/java/com/framsticks/gui/ObjectPanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/ObjectPanel.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/gui/ObjectPanel.java	(revision 84)
@@ -1,85 +1,45 @@
 package com.framsticks.gui;
 
-import com.framsticks.gui.components.Control;
-import com.framsticks.gui.components.ValueControl;
-import com.framsticks.gui.components.ValueControlListener;
+import com.framsticks.gui.controls.Control;
+import com.framsticks.gui.controls.ValueControl;
+import com.framsticks.gui.controls.ValueControlListener;
 import com.framsticks.params.AccessInterface;
-import com.framsticks.params.types.CompositeParam;
 import com.framsticks.params.Param;
-import com.framsticks.util.Strings;
+import com.framsticks.params.ValueParam;
+
 import org.apache.log4j.Logger;
 
 import javax.swing.*;
-import java.awt.*;
 import java.util.Collection;
 import java.util.HashMap;
 import java.util.Map;
-import java.util.List;
+import static com.framsticks.util.lang.Containers.filterInstanceof;
 
 @SuppressWarnings("serial")
-public class ObjectPanel extends com.framsticks.gui.Panel {
+public class ObjectPanel extends ModifiablePanel {
 
-	private static final Logger LOGGER = Logger.getLogger(ObjectPanel.class.getName());
+	private static final Logger log = Logger.getLogger(ObjectPanel.class.getName());
 
 	final protected Map<Param, Control> components = new HashMap<Param, Control>();
-	final protected Map<Param, ValueControl> valueComponents = new HashMap<Param, ValueControl>();
+	final protected Map<ValueParam, ValueControl> valueControls = new HashMap<ValueParam, ValueControl>();
 
-	public static void fillWithComponents(JPanel panel, Collection<Param> params, Map<Param, Control> components) {
-		for (Param param : params) {
-			if (param.isUserHidden()) {
-				continue;
-			}
-			assert !(param instanceof CompositeParam);
-			Control control = Control.createSuitable(param);
-			if (control != null) {
-				LOGGER.debug("add component for " + param);
-				JPanel line = new JPanel();
-				line.setLayout(new BoxLayout(line, BoxLayout.LINE_AXIS));
-				line.setAlignmentX(LEFT_ALIGNMENT);
-				JLabel label = new JLabel(Strings.notEmpty(param.getName()) ? param.getName() : "? (" + param.getId() + ")");
-				label.setToolTipText(label.getText());
-				label.setHorizontalAlignment(JLabel.RIGHT);
-				Dimension labelSize = new Dimension(150, 30);
-				label.setMaximumSize(labelSize);
-				label.setMinimumSize(labelSize);
-				label.setPreferredSize(labelSize);
-				line.add(label);
-				line.add(Box.createRigidArea(new Dimension(8, 0)));
-				line.add(control);
-				line.revalidate();
-				panel.add(line);
-				panel.add(Box.createRigidArea(new Dimension(0, 8)));
-				//component.setAlignmentX(LEFT_ALIGNMENT);
-				components.put(param, control);
-				continue;
-			}
-			LOGGER.error("component for param " + param + " of type " + param.getClass().getSimpleName() + " was not added");
-		}
+	public ObjectPanel(Panel.Parameters parameters, Collection<Param> params) {
+		super(parameters);
 
-	}
+		Gui.fillWithControls(contentPanel, params, components);
 
-	public ObjectPanel(EndpointAtFrame endpoint, String className, List<Param> params) {
-		super(endpoint, className);
-
-		fillWithComponents(contentPanel, params, components);
-
-		for (Map.Entry<Param, Control> e : components.entrySet()) {
-			Control control = e.getValue();
-			Param param = e.getKey();
-			if (control instanceof ValueControl) {
-				final ValueControl valueComponent = (ValueControl) control;
-				valueComponents.put(param, valueComponent);
-				valueComponent.setListener(new ValueControlListener() {
-					@Override
-					public boolean onChange(Object newValue) {
-						if (currentTreeNode == null) {
-							return true;
-						}
-						boolean result = currentTreeNode.changeValue(valueComponent, newValue);
-						refreshControlButtons();
-						return result;
+		for (final ValueControl c : filterInstanceof(components.values(), ValueControl.class)) {
+			valueControls.put(c.getParam(), c);
+			c.setListener(new ValueControlListener() {
+				@Override
+				public boolean onChange(Object newValue) {
+					if (currentTreeNode == null) {
+						return true;
 					}
-				});
-			}
+					boolean result = currentTreeNode.changeValue(c, newValue);
+					refreshControlButtons();
+					return result;
+				}
+			});
 		}
 		contentPanel.add(Box.createVerticalGlue());
@@ -91,65 +51,71 @@
 		assert frame.isActive();
 		assert currentTreeNode != null;
-		currentTreeNode.applyChanges();
+		currentTreeNode.pushLocalChanges();
 	}
 
 	protected void refreshControlButtons() {
 		assert frame.isActive();
-		applyButton.setEnabled(currentTreeNode.changedValues != null);
+		applyButton.setEnabled(currentTreeNode.localChanges != null);
+	}
+
+	protected static void fillControlsWithValues(Map<ValueControl, Object> map) {
 	}
 
 	@Override
-	public void refreshComponents(AccessInterface access) {
-        assert currentTreeNode.path.getInstance().isActive();
-        assert currentTreeNode != null;
-        LOGGER.debug("refreshing components");
+	public void pullValuesFromLocalToUser(AccessInterface access) {
+		assert currentTreeNode != null;
+		assert currentTreeNode.path.getInstance().isActive();
+		log.debug("refreshing components");
 
-        final Map<ValueControl, Object> values = new HashMap<ValueControl, Object>();
-        for (ValueControl vc : valueComponents.values()) {
-            Object value = access.get(vc.getParam().getId(), Object.class);
-            values.put(vc, value);
-        }
+		final Map<ValueControl, Object> values = new HashMap<ValueControl, Object>();
+		for (Map.Entry<ValueParam, ValueControl> e : valueControls.entrySet()) {
+			values.put(e.getValue(), access.get(e.getKey().getId(), Object.class));
+		}
 
-        frame.invokeLater(new Runnable() {
-            @Override
-            public void run() {
-                for (Map.Entry<ValueControl, Object> e : values.entrySet()) {
-                    e.getKey().setValue(e.getValue());
-                }
-				if (currentTreeNode.changedValues != null) {
-					for (Map.Entry<ValueControl, Object> e : currentTreeNode.changedValues.entrySet()) {
-						e.getKey().setValue(e.getValue());
+		frame.invokeLater(new Runnable() {
+			@Override
+			public void run() {
+				if (currentTreeNode.localChanges != null) {
+					for (Map.Entry<ValueControl, Object> e : currentTreeNode.localChanges.entrySet()) {
+						values.put(e.getKey(), e.getValue());
 					}
 				}
+				for (Map.Entry<ValueControl, Object> e : values.entrySet()) {
+					e.getKey().pushValueToUserInterface(e.getValue());
+				}
 				refreshControlButtons();
-                ObjectPanel.this.revalidate();
-            }
-        });
+				ObjectPanel.this.revalidate();
+			}
+		});
 
 	}
 
+	@Override
+	public String getTitle() {
+		return "Properties";
+	}
 
 
-/*	public void updateValue() {
-		//assert panel.getFrame().isActive();
+	// public void updateValue() {
+	// 	//assert panel.getFrame().isActive();
 
-        final Node n = panel.getCurrentNode();
-        panel.getBrowser().getManager().invokeLater(new Runnable() {
-            @Override
-            public void run() {
-                Object v = n.getAccess().get(param, Object.class);
-                if (v == null) {
-                    v = param.getDef(Object.class);
-                }
-                final Object fv = v;
-                panel.getBrowser().invokeLater(new Runnable() {
-                    @Override
-                    public void run() {
-                        setValueImpl(fv);
-                    }
-                });
-            }
-        });
-	}*/
+	// 	final Node n = panel.getCurrentNode();
+	// 	panel.getBrowser().getManager().invokeLater(new Runnable() {
+	// 		@Override
+	// 		public void run() {
+	// 			Object v = n.getAccess().get(param, Object.class);
+	// 			if (v == null) {
+	// 				v = param.getDef(Object.class);
+	// 			}
+	// 			final Object fv = v;
+	// 			panel.getBrowser().invokeLater(new Runnable() {
+	// 				@Override
+	// 				public void run() {
+	// 					setValueImpl(fv);
+	// 				}
+	// 			});
+	// 		}
+	// 	});
+	// }
 
 }
Index: java/main/src/main/java/com/framsticks/gui/Panel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Panel.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/gui/Panel.java	(revision 84)
@@ -2,77 +2,49 @@
 
 import com.framsticks.params.AccessInterface;
-import org.apache.log4j.Logger;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.FramsClass;
+// import org.apache.log4j.Logger;
 
 import javax.swing.*;
-import java.awt.*;
-import java.awt.event.ActionEvent;
-import java.awt.event.ActionListener;
 
 /**
- * @author Piotr Sniegowski
+ * Author: Piotr Śniegowski
  */
+@SuppressWarnings("serial")
 public abstract class Panel extends JPanel {
 
-	private static final Logger LOGGER = Logger.getLogger(Panel.class.getName());
+	public static class Parameters {
+		public final EndpointAtFrame endpoint;
+		public final CompositeParam param;
+		public final FramsClass framsClass;
 
-	/**
-	 * Pane to which components will be added.
-	 */
-	protected JPanel contentPanel;
+		public Parameters(EndpointAtFrame endpoint, CompositeParam param, FramsClass framsClass) {
+			this.endpoint = endpoint;
+			this.param = param;
+			this.framsClass = framsClass;
+		}
+	}
+
+	// private static final Logger log = Logger.getLogger(Panel.class.getName());
 
 	protected TreeNode currentTreeNode;
-    protected EndpointAtFrame endpoint;
-    protected final Frame frame;
+	protected final EndpointAtFrame endpoint;
+	protected final Frame frame;
 	protected final String className;
-	final protected JLabel label;
-	final protected JButton applyButton;
+	protected final FramsClass framsClass;
+	protected final CompositeParam param;
+	protected String uniqueName = "?";
 
-	public Panel(EndpointAtFrame endpoint, String className) {
-        this.endpoint = endpoint;
-		this.frame = endpoint.getFrame();
-		this.className = className;
-		LOGGER.debug("create panel for type: " + className);
-
-        endpoint.registerPanel(this);
-
-		contentPanel = new JPanel();
-		contentPanel.setLayout(new BoxLayout(contentPanel, BoxLayout.PAGE_AXIS));
-		JScrollPane scroll = new JScrollPane(contentPanel);
-		//scroll.setBorder(BorderFactory.createEtchedBorder());
-
-		JPanel pageEndPanel = new JPanel();
-		pageEndPanel.setLayout(new BoxLayout(pageEndPanel, BoxLayout.X_AXIS));
-		pageEndPanel.add(Box.createHorizontalGlue());
-
-		applyButton = new JButton("Apply");
-		applyButton.addActionListener(new ActionListener() {
-			public void actionPerformed(ActionEvent e) {
-				applyChanges();
-			}
-		});
-		pageEndPanel.add(applyButton);
-
-		pageEndPanel.add(Box.createHorizontalStrut(10));
-		pageEndPanel.setPreferredSize(new Dimension(0, 30));
-
-		label = new JLabel();
-		JPanel centerPanel = new JPanel();
-		centerPanel.setLayout(new BorderLayout());
-		centerPanel.add(Box.createHorizontalStrut(10), BorderLayout.LINE_START);
-		centerPanel.add(Box.createHorizontalStrut(10), BorderLayout.LINE_END);
-		centerPanel.add(label, BorderLayout.PAGE_START);
-		centerPanel.add(scroll, BorderLayout.CENTER);
-		centerPanel.add(pageEndPanel, BorderLayout.PAGE_END);
-
-		this.setLayout(new BorderLayout());
-		this.add(centerPanel, BorderLayout.CENTER);
-
-
+	public Panel(Parameters parameters) {
+		this.endpoint = parameters.endpoint;
+		this.frame = parameters.endpoint.getFrame();
+		this.framsClass = parameters.framsClass;
+		this.param = parameters.param;
+		this.className = parameters.param.getContainedTypeName();
+		this.setName(parameters.param.getFramsTypeName());
 	}
 
-	public void setCurrentTreeNode(TreeNode node) {
-		currentTreeNode = node;
-		//label.setText(node.getNode().getPath());
-		//this.revalidate();
+	public void setCurrentTreeNode(TreeNode currentTreeNode) {
+		this.currentTreeNode = currentTreeNode;
 	}
 
@@ -81,24 +53,28 @@
 	}
 
-	protected abstract void applyChanges();
-	public abstract void refreshComponents(AccessInterface access);
+	public final Frame getFrame() {
+		return frame;
+	}
+
+	public final EndpointAtFrame getEndpointAtFrame() {
+		return endpoint;
+	}
+
+
+	public final String getClassName() {
+		return className;
+	}
+
+	public abstract void pullValuesFromLocalToUser(AccessInterface access);
 
 	@Override
 	public String toString() {
-		return currentTreeNode == null ? "?" : currentTreeNode.toString();
+		return uniqueName;
 	}
 
-    public final Frame getFrame() {
-        return frame;
-    }
+	public final String getUniqueName() {
+		return uniqueName;
+	}
 
-
-    public final String getClassName() {
-        return className;
-    }
-
-    public final String getFullName() {
-        return className + "@" + endpoint.getName();
-    }
-
+	public abstract String getTitle();
 }
Index: java/main/src/main/java/com/framsticks/gui/PanelProvider.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/PanelProvider.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/PanelProvider.java	(revision 84)
@@ -0,0 +1,9 @@
+package com.framsticks.gui;
+
+
+/**
+ * Author: Piotr Śniegowski
+ */
+public interface PanelProvider {
+	public Panel providePanel(Panel.Parameters parameters);
+}
Index: java/main/src/main/java/com/framsticks/gui/StandardPanelProvider.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/StandardPanelProvider.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/StandardPanelProvider.java	(revision 84)
@@ -0,0 +1,28 @@
+package com.framsticks.gui;
+
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.types.ObjectParam;
+
+
+import org.apache.commons.collections.CollectionUtils;
+import org.apache.commons.collections.functors.InstanceofPredicate;
+import org.apache.commons.collections.functors.NotPredicate;
+
+
+/**
+ * Author: Piotr Śniegowski
+ */
+public class StandardPanelProvider implements PanelProvider {
+
+	@SuppressWarnings("unchecked")
+	@Override
+	public Panel providePanel(Panel.Parameters parameters) {
+		if (parameters.param instanceof ObjectParam) {
+			return new ObjectPanel(parameters, CollectionUtils.select(parameters.framsClass.getParamEntries(), new NotPredicate(new InstanceofPredicate(CompositeParam.class))));
+		}
+//		if (param instanceof ListParam) {
+//			return new ListPanel(endpoint);
+//		}
+		return null;
+	}
+}
Index: java/main/src/main/java/com/framsticks/gui/SwingDispatcher.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/SwingDispatcher.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/gui/SwingDispatcher.java	(revision 84)
@@ -1,9 +1,8 @@
 package com.framsticks.gui;
 
-import com.framsticks.util.Dispatcher;
-import com.framsticks.util.Task;
+import com.framsticks.util.dispatching.Dispatcher;
+import com.framsticks.util.dispatching.Task;
 
 import javax.swing.*;
-import java.awt.*;
 
 /**
@@ -12,25 +11,25 @@
 public class SwingDispatcher implements Dispatcher {
 
-    public static final SwingDispatcher instance = new SwingDispatcher();
+	public static final SwingDispatcher instance = new SwingDispatcher();
 
-    public SwingDispatcher() {
-        invokeLater(new Runnable() {
-            @Override
-            public void run() {
-                Thread.currentThread().setName("gui");
-            }
-        });
-    }
+	public SwingDispatcher() {
+		invokeLater(new Runnable() {
+			@Override
+			public void run() {
+				Thread.currentThread().setName("gui");
+			}
+		});
+	}
 
-    @Override
-    public final boolean isActive() {
-        return SwingUtilities.isEventDispatchThread();
-    }
+	@Override
+	public final boolean isActive() {
+		return SwingUtilities.isEventDispatchThread();
+	}
 
-    @Override
-    public final void invokeLater(Runnable runnable) {
-        assert !(runnable instanceof Task);
-        SwingUtilities.invokeLater(runnable);
-    }
+	@Override
+	public final void invokeLater(Runnable runnable) {
+		assert !(runnable instanceof Task);
+		SwingUtilities.invokeLater(runnable);
+	}
 
 }
